Attribute VB_Name = "Sorting"
Option Explicit

'######## Simple Sort
Public Sub SimpleSort(SortArray() As Integer)
   Dim Pass  As Integer
   Dim j     As Integer
   Dim ASize As Integer
   
   ASize = UBound(SortArray)
   LabelColours "Current Element", , "to be compared with"

   For Pass = 1 To ASize - 1
      For j = ASize To 2 Step -1
         Detail "Pass " & CStr(Pass), "Comparing Elements " & CStr(j) & " and " & CStr(j - 1)
         frm_SortMain.UpdateGraph SortArray, Pass, , j, , j - 1
         If SortArray(j - 1) > SortArray(j) Then Swap SortArray(j - 1), SortArray(j)
       Next j
       Detail "", "", ""
       frm_SortMain.UpdateGraph SortArray, Pass + 1
   Next Pass
   LabelColours
End Sub

'######## Bubble Sort
Public Sub BubbleSort(SortArray() As Integer)
   Dim Pass  As Integer
   Dim j     As Integer
   Dim ASize As Integer
   
   ASize = UBound(SortArray)
   LabelColours "Current Element", , "to be compared with"
   For Pass = 1 To ASize - 1
      For j = ASize To Pass + 1 Step -1
         Detail "Pass " & CStr(Pass), "Comparing Elements " & CStr(j) & " and " & CStr(j - 1)
         frm_SortMain.UpdateGraph SortArray, Pass, , j, , j - 1
         If SortArray(j - 1) > SortArray(j) Then Swap SortArray(j - 1), SortArray(j)
       Next j
       Detail "", "", ""
       frm_SortMain.UpdateGraph SortArray, Pass + 1
   Next Pass
   LabelColours
End Sub

'######## Bubble Stop Sort
Public Sub BubbleStopSort(SortArray() As Integer)
   Dim Pass     As Integer
   Dim j        As Integer
   Dim ASize    As Integer
   Dim Swapped  As Boolean
   
   ASize = UBound(SortArray)
   LabelColours "Current Element", , "to be compared with"
   Swapped = True
   Pass = 0
   While Swapped
      Swapped = False
      Pass = Pass + 1
      For j = ASize To Pass + 1 Step -1
         Detail "Pass " & CStr(Pass), "Comparing Elements " & CStr(j) & " and " & CStr(j - 1)
         frm_SortMain.UpdateGraph SortArray, Pass, , j, , j - 1
         If SortArray(j - 1) > SortArray(j) Then
            Swap SortArray(j - 1), SortArray(j)
            Swapped = True
         End If
       Next j
       Detail "", "", ""
       frm_SortMain.UpdateGraph SortArray, Pass + 1
   Wend
   LabelColours
End Sub

'######## Selection Sort
Public Sub SelectionSort(SortArray() As Integer)
   Dim Pass         As Integer
   Dim j            As Integer
   Dim jmin         As Integer
   Dim ASize        As Integer
   
   ASize = UBound(SortArray)
   LabelColours "Element being checked", , "Smallest element so far found"
   For Pass = 1 To ASize - 1
      jmin = Pass
      For j = Pass + 1 To ASize
         Detail "Pass " & CStr(Pass), "Best Candidate " & CStr(jmin), "Checking Element " & j
         frm_SortMain.UpdateGraph SortArray, Pass, , j, , jmin
         If SortArray(j) < SortArray(jmin) Then jmin = j
      Next j
      Swap SortArray(Pass), SortArray(jmin)
      Detail "Pass " & CStr(Pass), "Swapped Element " & CStr(Pass) & " with Element " & CStr(jmin)
      frm_SortMain.UpdateGraph SortArray, Pass + 1
   Next Pass
   Detail "", "", ""
   LabelColours
End Sub

'######## Insertion Sort
Public Sub InsertionSort(SortArray() As Integer)
   Dim Pass         As Integer
   Dim j            As Integer
   Dim Temp         As Integer
   Dim ASize        As Integer
   Dim NewPos       As Integer
   Dim Complete     As Boolean
   
   ASize = UBound(SortArray)
   LabelColours "Element to be inserted", , "Best location so far found"
   For Pass = 2 To ASize
      Detail "Looking for the location for Element " & CStr(Pass)
      frm_SortMain.UpdateGraph SortArray, Pass, , Pass
      
      NewPos = Pass
      Temp = SortArray(Pass)
      Complete = False
      
      While Not Complete
         Detail "Looking for the location for Element " & CStr(Pass), "Compare with Element " & CStr(NewPos - 1)
         frm_SortMain.UpdateGraph SortArray, Pass, , Pass, , NewPos - 1
         If Temp >= SortArray(NewPos - 1) Then
            Complete = True
         Else
            NewPos = NewPos - 1
            If NewPos = 1 Then Complete = True
         End If
      Wend
      
      Detail "Looking for the location for Element " & CStr(Pass), "Proper location found at " & CStr(NewPos)
      frm_SortMain.UpdateGraph SortArray, Pass, , Pass, , NewPos - 1

      For j = Pass To NewPos + 1 Step -1
         SortArray(j) = SortArray(j - 1)
      Next j
      
      Detail "Looking for the location for Element " & CStr(Pass), "Move the other Elements to make room"
      frm_SortMain.UpdateGraph SortArray, Pass + 1, , , , , NewPos

      SortArray(NewPos) = Temp
      Detail "Looking for the location for Element " & CStr(Pass), "Then slot it into its correct position."
      frm_SortMain.UpdateGraph SortArray, Pass + 1, , NewPos
      Detail "", "", ""
   Next Pass
   LabelColours
End Sub

'######## Shell Sort
Public Sub ShellSort(SortArray() As Integer)
   Dim Pass         As Integer
   Dim j            As Integer
   Dim h            As Integer
   Dim Temp         As Integer
   Dim ASize        As Integer
   Dim irem         As Integer
   Dim Complete     As Boolean
   Dim NewPos       As Integer
   
   ASize = UBound(SortArray)
   LabelColours "Element to be inserted", "Unsorted elements", "Sorted elements"
   h = 1
   Do
      h = 3 * h + 1
   Loop While h < ASize
   
   Do
      h = h \ 3
      
      For Pass = h + 1 To ASize
         Temp = SortArray(Pass)
         Complete = False
         NewPos = Pass
         
         While Not Complete
            If Temp >= SortArray(NewPos - h) Then
               Complete = True
            Else
               NewPos = NewPos - h
               If NewPos <= h Then Complete = True
            End If
         Wend
         
         Detail "h = " & CStr(h), "Place Element " & CStr(Pass) & " in its correct position"
         frm_SortMain.UpdateGraph SortArray, Pass, , , , NewPos, , Pass, h
         
         For j = Pass To NewPos + h Step -h
            SortArray(j) = SortArray(j - h)
         Next j
         
         SortArray(NewPos) = Temp
         

      Next Pass

   Loop Until h = 1
   LabelColours
End Sub

'######## Quick Sort
Public Sub QuickSort(SortArray() As Integer)
   QSort SortArray, 1, UBound(SortArray)
End Sub

Private Sub QSort(SortArray() As Integer, iExLeft As Integer, iExRight As Integer)
   Dim ILeft   As Long
   Dim IRight  As Long
   Dim iPivot  As Long
   Dim jPivot  As Long
   LabelColours "Pivot Element", "Element too large", "Element too small"
   
   iPivot = iExLeft + CLng(CDbl(iExRight - iExLeft) * Rnd())
   
   Detail "Select a pivot Element"
   frm_SortMain.UpdateGraph SortArray, iExLeft, iExRight, iPivot
   
   Swap SortArray(iExRight), SortArray(iPivot)
   jPivot = SortArray(iExRight)
   
   Detail "and put it at the extreme right of the section to be sorted"
   frm_SortMain.UpdateGraph SortArray, iExLeft, iExRight, iExRight
   
   ILeft = iExLeft - 1
   IRight = iExRight
   
   Do
      Do:  ILeft = ILeft + 1:     Loop Until SortArray(ILeft) >= jPivot
      Do:  IRight = IRight - 1:   Loop Until SortArray(IRight) <= jPivot
  
      If ILeft < IRight Then
         Detail "Two Elements found to be incorrectly placed..."
         frm_SortMain.UpdateGraph SortArray, iExLeft, iExRight, iExRight, ILeft, IRight
         Swap SortArray(ILeft), SortArray(IRight)
         Detail "so swap them"
         frm_SortMain.UpdateGraph SortArray, iExLeft, iExRight, iExRight, ILeft, IRight
      End If
         
   Loop Until ILeft >= IRight 'SortArray(ILeft) will be >= jpivot
   
   Swap SortArray(ILeft), SortArray(iExRight)
   Detail "Then put the pivot element back in its correct slot", "and start the next pass"
   frm_SortMain.UpdateGraph SortArray, iExLeft, iExRight, ILeft
   Detail "", "", ""
   If iExLeft < ILeft - 1 Then QSort SortArray, iExLeft, ILeft - 1
   If ILeft + 1 < iExRight Then QSort SortArray, ILeft + 1, iExRight
   
End Sub


'##### Merge Sort
Public Sub MergeSort(SortArray() As Integer)
   MSort SortArray, 1, UBound(SortArray)
End Sub
Private Sub MSort(SortArray() As Integer, iExLeft As Integer, iExRight As Integer)
   Dim IMiddle As Integer
   Dim i       As Integer
   Dim j       As Integer
   Dim iSort   As Integer
   Dim TFinish As Boolean
   
   Dim Temp()  As Integer
   LabelColours "Merged Elements", "Left part, sorted", "Right part, sorted"
   IMiddle = (iExLeft + iExRight) \ 2
   
   If iExLeft < IMiddle Then MSort SortArray, iExLeft, IMiddle
   If IMiddle + 1 < iExRight Then MSort SortArray, IMiddle + 1, iExRight
   
   Detail "The two subsections are sorted... ", "so merge them together"
   frm_SortMain.UpdateGraph SortArray, iExLeft, iExRight, , , , , , , iExLeft, IMiddle, iExRight
  
   ReDim Temp(iExRight - iExLeft + 1)
   
   iSort = 1
   i = iExLeft
   j = IMiddle + 1
   
   Do While i <= IMiddle And j <= iExRight
      If SortArray(i) < SortArray(j) Then
         Temp(iSort) = SortArray(i)
         i = i + 1
      Else
         Temp(iSort) = SortArray(j)
         j = j + 1
      End If
      iSort = iSort + 1
   Loop
    
   Do While i <= IMiddle
      Temp(iSort) = SortArray(i)
      i = i + 1
      iSort = iSort + 1
   Loop
   
   Do While j <= iExRight
   Temp(iSort) = SortArray(j)
      j = j + 1
      iSort = iSort + 1
   Loop
   
   For iSort = 1 To iExRight - iExLeft + 1
      SortArray(iExLeft - 1 + iSort) = Temp(iSort)
   Next iSort
   Detail "Two sections merged.", "", ""
   frm_SortMain.UpdateGraph SortArray, iExLeft, iExRight, , , , , , , iExLeft, , iExRight
   Detail "", "", ""
End Sub


'########  Swap ######

Private Sub Swap(x As Integer, y As Integer)
   Dim Temp As Integer
   Temp = y
   y = x
   x = Temp
End Sub

Public Sub Finish()
   End
End Sub
Private Sub LabelColours(Optional sred As Variant, Optional syellow As Variant, Optional sgreen As Variant, Optional sblue As Variant)
   With frm_SortMain
      .lin_exred.Visible = Not IsMissing(sred)
      .lin_exyellow.Visible = Not IsMissing(syellow)
      .lin_exgreen.Visible = Not IsMissing(sgreen)
      .lin_exblue.Visible = Not IsMissing(sblue)
      .lbl_red.Caption = IIf(IsMissing(sred), "", sred)
      .lbl_yellow.Caption = IIf(IsMissing(syellow), "", syellow)
      .lbl_green.Caption = IIf(IsMissing(sgreen), "", sgreen)
      .lbl_blue.Caption = IIf(IsMissing(sblue), "", sblue)
   End With
End Sub
Private Function Detail(string1 As String, Optional string2 As String, Optional string3 As String)
   With frm_SortMain
      .lbl_1.Caption = string1
      .lbl_2.Caption = string2
      .lbl_3.Caption = string3
   End With
End Function
